-- AI FLIGHT GROUPS TABLE*****************************************************************
local REDAICAPTEMPLATE = {"REDAI CAP F4-E", "REDAI CAP SU27", "REDAI CAP MIG29", "REDAI CAP F15"}
local REDAICASGROUPS = {"REDAICAS SU25T", "REDAICAS A10A"}
local BLUEAICAPTEMPLATE = {"BLUEAI CAP F4-E", "BLUEAI CAP SU27", "BLUEAI CAP MIG29", "BLUEAI CAP F15"}
local BLUEAICASGROUPS = {"BLUEAICAS SU25T", "BLUEAICAS A10A"}
--SUPPORT COLUMN TEMPLATE***************************************
local BLUESupColumnTemplate = {"BLUEAtkColTemplate1", "BLUEAtkColTemplate2", "BLUEAtkColTemplate3", "BLUEAtkColTemplate4", "BLUEAtkColTemplate5", "BLUEAtkColTemplate6"}
local REDSupColumnTemplate = {"REDAtkColTemplate1", "REDAtkColTemplate2", "REDAtkColTemplate3", "REDAtkColTemplate4", "REDAtkColTemplate5", "REDAtkColTemplate6"}
--Чистка аэропортов от мусора

local CleanUpAirbase = CLEANUP_AIRBASE:New({AIRBASE.Caucasus.Tbilisi_Lochini, AIRBASE.Caucasus.Senaki_Kolkhi, AIRBASE.Caucasus.Vaziani, AIRBASE.Caucasus.Soganlug})

--описываем захватываемые зоны
--GomiZone
GomiCapZone = ZONE:New("GomiCapZone")
GomiCaptureZone = ZONE_CAPTURE_COALITION:New( GomiCapZone , coalition.side.BLUE )
GomiCapZoneSide = coalition.side.BLUE

--HashuriZone
HashuriCapZone = ZONE:New("HashuriCapZone")
HashuriCaptureZone = ZONE_CAPTURE_COALITION:New( HashuriCapZone , coalition.side.BLUE )
HashuriCapZoneSide = coalition.side.BLUE

--SuramiZone
SuramiCapZone = ZONE:New("SuramiCapZone")
SuramiCaptureZone = ZONE_CAPTURE_COALITION:New( SuramiCapZone , coalition.side.RED )
SuramiCapZoneSide = coalition.side.RED 

--CipaZone
CipaCapZone = ZONE:New("CipaCapZone")
CipaCaptureZone = ZONE_CAPTURE_COALITION:New( CipaCapZone , coalition.side.RED )
CipaCapZoneSide = coalition.side.RED

--патрульные зоны для самолетов CAP
AIPatrolZone = ZONE:New("AIPatrolZone")
AIEngageZone = ZONE:New("AIEngageZone")
BLUEAICapZone = AI_CAP_ZONE:New(AIPatrolZone,1000,9000,300,1300)
REDAICapZone = AI_CAP_ZONE:New(AIPatrolZone,1000,9000,300,1300)

--переменные для бомберов

BLUEBomberAlive = false
REDBomberAlive = false

BlueBomberAtkZone = SuramiCapZone
RedBomberAtkZone = HashuriCapZone

-- AI_BALANCERER *****************************************************************************************************

-- получаем списки игроков и ботов 
local REDCAPSet = SET_GROUP:New():FilterCoalitions("red"):FilterCategories("plane"):FilterPrefixes("REDCAP"):FilterActive() --:FilterStart()
local BLUECAPSet = SET_GROUP:New():FilterCoalitions("blue"):FilterCategories("plane"):FilterPrefixes("BLUECAP"):FilterActive() --:FilterStart()
local REDAICAPSet = SET_GROUP:New():FilterCoalitions("red"):FilterCategories("plane"):FilterPrefixes("REDAICAP"):FilterActive() --:FilterStart()
local BLUEAICAPSet = SET_GROUP:New():FilterCoalitions("blue"):FilterCategories("plane"):FilterPrefixes("BLUEAICAP"):FilterActive() --:FilterStart()


--объявляем спауны RED и BLUE истребителей
RED_AI_CAP = SPAWN
:New("REDAICAP")
:InitRandomizeTemplate(REDAICAPTEMPLATE)
:InitLimit(10,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (capGroup)
    REDAICapZone:SetControllable(capGroup)
    REDAICapZone:SetEngageZone( AIEngageZone )
    REDAICapZone:__Start(1)    
  end
)

BLUE_AI_CAP = SPAWN
:New("BLUEAICAP")
:InitRandomizeTemplate(BLUEAICAPTEMPLATE)
:InitLimit(10,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (capGroup)
    BLUEAICapZone:SetControllable(capGroup)
    BLUEAICapZone:SetEngageZone( AIEngageZone )
    BLUEAICapZone:__Start(1)
  end
)

--создаем функцию подсчета игроков и ботов, в ней же будем спавнить бота если надо
local  function CAPAIBalancer()
    REDCAPSet:FilterOnce()
    BLUECAPSet:FilterOnce()
    REDAICAPSet:FilterOnce()
    BLUEAICAPSet:FilterOnce()
    local REDCAPCounter = REDCAPSet:CountAlive()
    local BLUECAPCounter = BLUECAPSet:CountAlive()
    local REDAICAPCounter = REDAICAPSet:CountAlive()
    local BLUEAICAPCounter = BLUEAICAPSet:CountAlive()

    if REDCAPCounter == nil then
      REDCAPCounter = 0
    end
    if REDAICAPCounter == nil then
      REDAICAPCounter = 0
    end
    if BLUECAPCounter == nil then
      BLUECAPCounter = 0
    end
    if BLUEAICAPCounter == nil then
      BLUEAICAPCounter = 0
    end

    local REDTotal = REDCAPCounter + REDAICAPCounter
    env.info("REDCAPTotal ..."..REDTotal)
    trigger.action.outText("Красных истребителей в воздухе ..."..REDTotal, 5)
    local BLUETotal = BLUECAPCounter + BLUEAICAPCounter
    env.info("BLUETCAPotal ..."..BLUETotal)
    trigger.action.outText("Синих истребителей в воздухе ..."..BLUETotal, 5)

--сравниваем кол-во игроков в командах и добавляем недостающих ботов истребителей
    if REDTotal > BLUETotal then
--      if BLUEAICAPCounter == 0 then
--          for i = 1, REDTotal do
--            env.info("SPAWNING BLUECAP ..."..i)
            env.info("SPAWNING BLUECAP ...")
            BLUE_AI_CAP:Spawn()
--          end
--      end
    end
    if BLUETotal > REDTotal then
--      if REDAICAPCounter == 0 then
--        for i = 1, BLUETotal do
--          env.info("SPAWNING REDCAP ..."..i)
          env.info("SPAWNING REDCAP ...")
          RED_AI_CAP:Spawn()
 --       end
--      end
    end
end

--создаем расписание для запуска фкуции проверки
local CAPAI_SCHEDULER = SCHEDULER:New(nil,
  function()
    CAPAIBalancer()
  end,
  {}, 1, 900 )
  

local REDCASSet = SET_GROUP:New():FilterCoalitions("red"):FilterCategories("plane"):FilterPrefixes("REDCAS"):FilterActive()
local BLUECASSet = SET_GROUP:New():FilterCoalitions("blue"):FilterCategories("plane"):FilterPrefixes("BLUECAS"):FilterActive()
local REDAICASSet = SET_GROUP:New():FilterCoalitions("red"):FilterCategories("plane"):FilterPrefixes("REDAICAS"):FilterActive()
local BLUEAICASSet = SET_GROUP:New():FilterCoalitions("blue"):FilterCategories("plane"):FilterPrefixes("BLUEAICAS"):FilterActive()


local RED_AI_CAS = SPAWN
:New("REDAICAS")
:InitRandomizeTemplate(REDAICASGROUPS)
:InitLimit(4,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)

local BLUE_AI_CAS = SPAWN
:New("BLUEAICAS")
:InitRandomizeTemplate(BLUEAICASGROUPS)
:InitLimit(4,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)

local  function CASAIBalancer()
    REDCASSet:FilterOnce()
    BLUECASSet:FilterOnce()
    REDAICASSet:FilterOnce()
    BLUEAICASSet:FilterOnce()
    local REDCASCounter = REDCASSet:CountAlive()
    local BLUECASCounter = BLUECASSet:CountAlive()
    local REDAICASCounter = REDAICASSet:CountAlive()
    local BLUEAICASCounter = BLUEAICASSet:CountAlive()

    if REDCASCounter == nil then
      REDCASCounter = 0
    end
    if BLUECASCounter == nil then
      BLUECASCounter = 0
    end
    if REDAICASCounter == nil then
      REDAICASCounter = 0
    end
    if BLUEAICASCounter == nil then
      BLUEAICASCounter = 0
    end
     
    local REDCASTotal = REDCASCounter + REDAICASCounter
    env.info("REDCASTotal ..."..REDCASTotal)
    trigger.action.outText("Красных штурмовиков ..."..REDCASTotal, 5)
    local BLUECASTotal = BLUECASCounter + BLUEAICASCounter
    env.info("BLUECASTotal ..."..BLUECASTotal)
    trigger.action.outText("Синих штурмовиков ..."..BLUECASTotal, 5)
    
    --сравниваем кол-во игроков в командах и добавляем недостающих ботов штурмовиков
    if REDCASTotal > BLUECASTotal then
      env.info("SPAWNING BLUECAS ...")
      BLUE_AI_CAS:Spawn()
    end
    if BLUECASTotal > REDCASTotal then
      env.info("SPAWNING REDCAS ...")
      RED_AI_CAS:Spawn()
    end
end

local CASAI_SCHEDULER = SCHEDULER:New(nil,
  function()
    CASAIBalancer()
  end,
  {}, 2, 900 )
  

-- ADD RADIO MENUS ***************************************************************************************

--local function RefreshClientMenus()
--  
--  _SETTINGS:SetPlayerMenuOff()
--
--  BLUECAPSet:ForEachGroup(
--    function( BLUECAPSet )
--      TestMenuStart = MENU_GROUP:New(BLUECAPSet,"РњРµРЅСЋ СЃРїР°РІРЅР° Р±РѕС‚РѕРІ ")
--      TestFlag1Set1 = MENU_GROUP_COMMAND:New(BLUECAPSet, "Р—Р°СЃРїР°РІРЅРёС‚СЊ РєСЂР°СЃРЅС‹Р№ CAP", TestMenuStart, SpawnRedCAP)
--      TestFlag2Set1 = MENU_GROUP_COMMAND:New(BLUECAPSet, "Р—Р°СЃРїР°РІРЅРёС‚СЊ СЃРёРЅРёР№ CAP", TestMenuStart, SpawnBlueCAP)
--    end 
--  )
--end  
--   
--MenuRefresher = SCHEDULER:New( nil, 
--  function()
--  RefreshClientMenus()
--  end, {}, 1, 5
--)



-- NPC's ****************************************

BLUEJTACHashuri = SPAWN:New("BLUEJTACHashuri")
:InitLimit(1,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (jtacgroup)
    jtacgroup:HandleEvent(EVENTS.Dead)
    
    function jtacgroup:OnEventDead(EventData)
      trigger.action.outTextForCoalition(coalition.side.BLUE, "Наш JTAC сбит! Следующий взлетит через 15 минут.", 15 , false)
      BLUEJTACHashuri:SpawnScheduleStop()
      BLUEJTACHashuriTimeout:Start()
    end
  end
)
:SpawnScheduled(60,0)

BLUEJTACHashuriTimeout = SCHEDULER:New(nil,
  function()
    BLUEJTACHashuri:SpawnScheduleStart()
    trigger.action.outTextForCoalition(coalition.side.BLUE, "Новый JTAC готовится на взлет.", 15 , false)
  end,
  {}, 900 )

REDJTACSurami = SPAWN:New("REDJTACSurami")
:InitLimit(1,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (jtacgroup)
    jtacgroup:HandleEvent(EVENTS.Dead)
    
    function jtacgroup:OnEventDead(EventData)
      trigger.action.outTextForCoalition(coalition.side.RED, "Наш JTAC сбит! Следующий взлетит через 15 минут.", 15 , false)
      REDJTACSurami:SpawnScheduleStop()
      REDJTACHashuriTimeout:Start()
    end
  end
)
:SpawnScheduled(60,0)

REDJTACHashuriTimeout = SCHEDULER:New(nil,
  function()
    REDJTACSurami:SpawnScheduleStart()
    trigger.action.outTextForCoalition(coalition.side.RED, "Новый JTAC готовится на взлет.", 15 , false)
  end,
  {}, 900 )

--INTERCEPTORS***********************************************************************************************************************************************
BLUEInterceptor = SPAWN:New("BLUEInterceptor")
:InitLimit(2,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (capGroup)
    BLUEAICapZone:SetControllable(capGroup)
    BLUEAICapZone:SetEngageRange(40000)
    BLUEAICapZone:__Start(1)
  end
)
:SpawnScheduled(30,0)

REDInterceptor = SPAWN:New("REDInterceptor")
:InitLimit(2,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (capGroup)
    REDAICapZone:SetControllable(capGroup)
    REDAICapZone:SetEngageRange(40000)
    REDAICapZone:__Start(1)    
  end
)
:SpawnScheduled(30,0)

--ADD BOMBERS**********************************************************************************

BLUEBomber = SPAWN
:New("BLUEBomber")
:InitLimit(1,0)
:InitCleanUp(60)
:OnSpawnGroup(
  function (Bomber)
    Bomber:HandleEvent(EVENTS.Crash)
    Bomber:HandleEvent(EVENTS.EngineShutdown)
    BLUEBomberAlive = true
    
    function Bomber:OnEventCrash(EventData)
      REDAwacs:SpawnScheduleStart()
      trigger.action.outText("Бомбардировщик синей коалиции сбит.", 15)
      BLUEBomberAlive = false
    end
    
    function Bomber:OnEventEngineShutdown(EventData)
      BLUEBomberAlive = false
--      trigger.action.outTextForCoalition(coalition.side.BLUE, "Наш бомбардировщик вернулся на базу.", 15 , false)
      Bomber:Destroy(true)
    end
  end
)

REDBomber = SPAWN
:New("REDBomber")
:InitLimit(1,0)
:InitCleanUp(60)
:OnSpawnGroup(
  function (Bomber)
    Bomber:HandleEvent(EVENTS.Crash)
    Bomber:HandleEvent(EVENTS.EngineShutdown)
    REDBomberAlive = true
    
    function Bomber:OnEventCrash(EventData)
      BLUEAwacs:SpawnScheduleStart()
      trigger.action.outText("Бомбардировщик красной коалиции сбит.", 15)
      REDBomberAlive = false
    end
    
    function Bomber:OnEventEngineShutdown(EventData)
      REDBomberAlive = false
--      trigger.action.outTextForCoalition(coalition.side.RED, "Наш бомбардировщик вернулся на базу.", 15 , false)
      Bomber:Destroy(true)
    end
  end
)

function BLUEBomberFunc()
  local BomberGroup = BLUEBomber:GetLastAliveGroup()
  local task = BomberGroup:TaskBombing(BlueBomberAtkZone:GetRandomVec2() , BomberGroup , AI.Task.WeaponExpend.ALL , 1 , nil , 7000 , nil , false)
  BomberGroup:PushTask(task, 1)
  REDAwacs:SpawnScheduleStart()
  trigger.action.outTextForCoalition(coalition.side.BLUE, "Наш бомбардировщик определил цель и готовится сбросить бомбы.", 15 , false)
end

function REDBomberFunc()
  local BomberGroup = REDBomber:GetLastAliveGroup()
  local task = BomberGroup:TaskBombing(RedBomberAtkZone:GetRandomVec2() , BomberGroup , AI.Task.WeaponExpend.ALL , 1 , nil , 7000 , nil , false)
  BomberGroup:PushTask(task, 1)
  BLUEAwacs:SpawnScheduleStart()
  trigger.action.outTextForCoalition(coalition.side.RED, "Наш бомбардировщик определил цель и готовится сбросить бомбы.", 15 , false)
end

--AWACS******************************************************************************************************************************************************************

BLUEAwacs = SPAWN:New("BLUEAwacs")
:InitLimit(1,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (drlogroup)
    drlogroup:HandleEvent(EVENTS.Crash)
    drlogroup:HandleEvent(EVENTS.Ejection)

    function drlogroup:OnEventEjection(EventData)
      if REDBomberAlive == false then 
        BLUEAwacs:SpawnScheduleStop()
      end
    end
    
    function drlogroup:OnEventCrash(EventData)
      if REDBomberAlive == false then 
        REDBomber:Spawn()
        trigger.action.outTextForCoalition(coalition.side.BLUE, "Наш самолет ДРЛО сбит! Враги могут воспользоваться ситуацией и выслать бомбардировщик, до того как мы успеем запустить новый ДРЛО!", 40 , false)
        trigger.action.outTextForCoalition(coalition.side.RED, "Вражеский ДРЛО сбит! Мы высылаем тактический бомбардировщик на фронт, прикройте его по возможности!", 40 , false)
      else
        trigger.action.outTextForCoalition(coalition.side.BLUE, "Наш самолет ДРЛО сбит! Мы подготавливаем следующий самолет к запуску!", 40 , false)
        trigger.action.outTextForCoalition(coalition.side.RED, "Вражеский ДРЛО сбит! У нас есть немного времени, пока враг готовит новый самолет!", 40 , false)
      end
    end
  end
)
:SpawnScheduled(60,0)

REDAwacs = SPAWN:New("REDAwacs")
:InitLimit(1,0)
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (drlogroup)
    drlogroup:HandleEvent(EVENTS.Crash)
    drlogroup:HandleEvent(EVENTS.Ejection)

    function drlogroup:OnEventEjection(EventData)
      if BLUEBomberAlive == false then 
        REDAwacs:SpawnScheduleStop()
      end
    end
    
    function drlogroup:OnEventCrash(EventData)
      if BLUEBomberAlive == false then 
        BLUEBomber:Spawn()
        trigger.action.outTextForCoalition(coalition.side.RED, "Наш самолет ДРЛО сбит! Враги могут воспользоваться ситуацией и выслать бомбардировщик, до того как мы успеем запустить новый ДРЛО!", 40 , false)
        trigger.action.outTextForCoalition(coalition.side.BLUE, "Вражеский ДРЛО сбит! Мы высылаем тактический бомбардировщик на фронт, прикройте его по возможности!", 40 , false)
      else
        trigger.action.outTextForCoalition(coalition.side.RED, "Наш самолет ДРЛО сбит! Мы подготавливаем следующий самолет к запуску!", 40 , false)
        trigger.action.outTextForCoalition(coalition.side.BLUE, "Вражеский ДРЛО сбит! У нас есть немного времени, пока враг готовит новый самолет!", 40 , false)
      end
    end
  end
)
:SpawnScheduled(60,0)

--ЗОНЫ ЗАХВАТА***************************************************************************************************************************

--Gomi Groups***
BLUEGomiForcesTanks = SPAWN:New("BLUEGomiForcesTanks")
BLUEGomiForcesTanks:Spawn()
BLUEGomiForcesSAM = SPAWN:New("BLUEGomiForcesSAM")
BLUEGomiForcesSAM:Spawn()
BLUEGomiForcesSoldiers = SPAWN:New("BLUEGomiForcesSoldiers")
BLUEGomiForcesSoldiers:Spawn()
BLUEHashuriAtkColumn = SPAWN:New("BLUEHashuriAtkColumn")
BLUEHashuriAtkSoldiers = SPAWN:New("BLUEHashuriAtkSoldiers")

BLUESupportColumn = SPAWN:New("BLUESupportColumn")  --выполняет функции BLUESupportColumnGomiFunc() на ппм 2, BLUESupportColumnHashuriFunc() на ппм 5, BLUESupportColumnSuramiFunc() на ппм 9
:InitLimit(6,0)
:OnSpawnGroup(
  function (SupColumn)
    SupColumn:HandleEvent(EVENTS.Dead)
    trigger.action.outTextForCoalition(coalition.side.RED, "Синяя колонна выезжает из Агары, сектор MM05", 40 , false)
      function SupColumn:OnEventDead(EventData)
        if SupColumn:CountAliveUnits() == 0 then
          BLUESupportColumn:SpawnScheduleStop()
          BLUESupColTimeout:Start()
          trigger.action.outText("Синяя колонна уничтожена, следующая будет через 10 минут", 40)
        end
      end
  end
)
:SpawnScheduled(30,0)

BLUEHeliMarineGomi = SPAWN:New("BLUEHeliMarineGomi")  --выполняет скрипт BLUEHashuriAtkSoldiers:Spawn() при проходе ППМ5
:OnSpawnGroup(
  function (HeliMarine)
    HeliMarine:HandleEvent(EVENTS.Dead)
    HeliMarine:HandleEvent(EVENTS.EngineShutdown)
      function HeliMarine:OnEventDead(EventData)
        if GomiCapZoneSide == coalition.side.BLUE then
          BLUEHeliMarineGomi_SCHEDULER:Start()
          trigger.action.outText("Синий вертолет поддержки уничтожен, следующий вертолет вылетает через 10 минут", 15)
        end
      end
      function HeliMarine:OnEventEngineShutdown(EventData)
        HeliMarine:Destroy()
        if GomiCapZoneSide == coalition.side.BLUE then
          BLUEHeliMarineGomi:Spawn()
        end
      end
  end
)

--Hashuri GROUPS******
BLUEHashuriForcesTanks = SPAWN:New("BLUEHashuriForcesTanks")
BLUEHashuriForcesTanks:Spawn()
BLUEHashuriForcesSAM = SPAWN:New("BLUEHashuriForcesSAM")
BLUEHashuriForcesSAM:Spawn()
BLUEHashuriForcesSoldiers = SPAWN:New("BLUEHashuriForcesSoldiers")
BLUEHashuriForcesSoldiers:Spawn()
BLUESuramiAtkColumn = SPAWN:New("BLUESuramiAtkColumn")
BLUESuramiAtkSoldiers = SPAWN:New("BLUESuramiAtkSoldiers")
BLUESuramiAtkSoldiers:Spawn()
--BLUEHashuriSupportColumn = SPAWN:New("BLUEHashuriSupportColumn")  -- выполняет функцию BLUEHashuriSupColFunc() в конце маршрута
--:OnSpawnGroup(
--  function (SupColumn)
--    SupColumn:HandleEvent(EVENTS.Dead)
--      function SupColumn:OnEventDead(EventData)
--        if HashuriCapZoneSide == coalition.side.BLUE then
--          BLUEHashuriSupportColumn_SCHEDULER:Start()
--          trigger.action.outText("Синяя колонна поддержки уничтожена, следующая колонна выдвигается через 10 минут", 10)
--        end
--      end
--  end
--)
--BLUEHashuriSupColOBJ1 = BLUEHashuriSupportColumn:Spawn()

BLUEHeliMarineHashuri = SPAWN:New("BLUEHeliMarineHashuri")   --выполняет скрипт BLUESuramiAtkSoldiers:Spawn() при проходе ППМ3
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (HeliMarine)
    HeliMarine:HandleEvent(EVENTS.Dead)
      
      function HeliMarine:OnEventDead(EventData)
        if HashuriCapZoneSide == coalition.side.BLUE then
          BLUEHeliMarineHashuri_SCHEDULER:Start()
          trigger.action.outText("Синий вертолет поддержки уничтожен, следующий вертолет вылетает через 10 минут", 15)
        end
      end
  end
)
BLUEHeliMarineHashuri:Spawn()

REDHashuriForcesTanks = SPAWN:New("REDHashuriForcesTanks")
REDHashuriForcesSAM = SPAWN:New("REDHashuriForcesSAM")
REDHashuriForcesSoldiers = SPAWN:New("REDHashuriForcesSoldiers")
REDGomiAtkColumn = SPAWN:New("REDGomiAtkColumn")
REDGomiAtkSoldiers = SPAWN:New("REDGomiAtkSoldiers")

--REDHashuriSupportColumn = SPAWN:New("REDHashuriSupportColumn")
--:OnSpawnGroup(
--  function (SupColumn)
--    SupColumn:HandleEvent(EVENTS.Dead)
--      function SupColumn:OnEventDead(EventData)
--        if HashuriCapZoneSide == coalition.side.RED then
--          REDHashuriSupportColumn_SCHEDULER:Start()
--          trigger.action.outText("Красная колонна поддержки уничтожена, следующая колонна выдвигается через 10 минут", 10)
--        end
--      end
--  end
--)

REDHeliMarineHashuri = SPAWN:New("REDHeliMarineHashuri")
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (HeliMarine)
    HeliMarine:HandleEvent(EVENTS.Dead)

      function HeliMarine:OnEventDead(EventData)
        if HashuriCapZoneSide == coalition.side.RED then
          REDHeliMarineHashuri_SCHEDULER:Start()
          trigger.action.outText("Синий вертолет поддержки уничтожен, следующий вертолет вылетает через 10 минут", 15)
        end
      end
  end
)


--Surami GROUPS****************
BLUESuramiForcesTanks = SPAWN:New("BLUESuramiForcesTanks")
BLUESuramiForcesSAM = SPAWN:New("BLUESuramiForcesSAM")
BLUESuramiForcesSoldiers = SPAWN:New("BLUESuramiForcesSoldiers")
BLUECipaAtkColumn = SPAWN:New("BLUECipaAtkColumn")
BLUECipaAtkSoldiers = SPAWN:New("BLUECipaAtkSoldiers")
--BLUESuramiSupportColumn = SPAWN:New("BLUESuramiSupportColumn")  --в конце пути выполняет функцию REDHashuriSupColFunc()
--:OnSpawnGroup(
--  function (SupColumn)
--    SupColumn:HandleEvent(EVENTS.Dead)
--      function SupColumn:OnEventDead(EventData)
--        if SuramiCapZoneSide == coalition.side.BLUE then
--          BLUESuramiSupportColumn_SCHEDULER:Start()
--          trigger.action.outText("Синяя колонна поддержки уничтожена, следующая колонна выдвигается через 10 минут", 10)
--        end
--      end
--  end
--)
BLUEHeliMarineSurami = SPAWN:New("BLUEHeliMarineSurami")
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (HeliMarine)
    HeliMarine:HandleEvent(EVENTS.Dead)

      function HeliMarine:OnEventDead(EventData)
        if SuramiCapZoneSide == coalition.side.BLUE then
          BLUEHeliMarineSurami_SCHEDULER:Start()
          trigger.action.outText("Синий вертолет поддержки уничтожен, следующий вертолет вылетает через 10 минут", 15)
        end
      end
  end
)

REDSuramiForcesTanks = SPAWN:New("REDSuramiForcesTanks")
REDSuramiForcesTanks:Spawn()
REDSuramiForcesSAM = SPAWN:New("REDSuramiForcesSAM")
REDSuramiForcesSAM:Spawn()
REDSuramiForcesSoldiers = SPAWN:New("REDSuramiForcesSoldiers")
REDSuramiForcesSoldiers:Spawn()
REDHashuriAtkSoldiers = SPAWN:New("REDHashuriAtkSoldiers")
REDHashuriAtkSoldiers:Spawn()
REDHashuriAtkColumn = SPAWN:New("REDHashuriAtkColumn")

--REDSuramiSupportColumn = SPAWN:New("REDSuramiSupportColumn")  --выполняет REDSuramiSupColFunc() по прибытии на последнюю точку
--:OnSpawnGroup(
--  function (SupColumn)
--    SupColumn:HandleEvent(EVENTS.Dead)
--      function SupColumn:OnEventDead(EventData)
--        if SuramiCapZoneSide == coalition.side.RED then
--          REDSuramiSupportColumn_SCHEDULER:Start()
--          trigger.action.outText("Красная колонна поддержки уничтожена, следующая колонна выдвигается через 10 минут", 10)
--        end
--      end
--  end
--)
--REDSuramiSupColOBJ1 = REDSuramiSupportColumn:Spawn()

REDHeliMarineSurami = SPAWN:New("REDHeliMarineSurami") --выполняет REDHashuriAtkSoldiers:Spawn() на 4 ППМ
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (HeliMarine)
    HeliMarine:HandleEvent(EVENTS.Dead)
    
      function HeliMarine:OnEventDead(EventData)
        if SuramiCapZoneSide == coalition.side.RED then
          REDHeliMarineSurami_SCHEDULER:Start()
          trigger.action.outText("Красный вертолет поддержки уничтожен, следующий вертолет вылетает через 10 минут", 15)
        end
      end
  end
)
REDHeliMarineSurami:Spawn()

--Cipa GROUPS*****************************
BLUECipaForcesTanks = SPAWN:New("BLUECipaForcesTanks")
BLUECipaForcesSAM = SPAWN:New("BLUECipaForcesSAM")
BLUECipaForcesSoldiers = SPAWN:New("BLUECipaForcesSoldiers")


REDCipaForcesTanks = SPAWN:New("REDCipaForcesTanks")
REDCipaForcesTanks:Spawn()
REDCipaForcesSAM = SPAWN:New("REDCipaForcesSAM")
REDCipaForcesSAM:Spawn()
REDCipaForcesSoldiers = SPAWN:New("REDCipaForcesSoldiers")
REDCipaForcesSoldiers:Spawn()
REDSuramiAtkColumn = SPAWN:New("REDSuramiAtkColumn")
REDSuramiAtkSoldiers = SPAWN:New("REDSuramiAtkSoldiers")
REDHeliMarineCipa = SPAWN:New("REDHeliMarineCipa")
:InitRepeatOnEngineShutDown()
:InitCleanUp(60)
:OnSpawnGroup(
  function (HeliMarine)
    HeliMarine:HandleEvent(EVENTS.Dead)

      function HeliMarine:OnEventDead(EventData)
        REDHeliMarineCipa_SCHEDULER:Start()
        trigger.action.outText("Красный вертолет поддержки уничтожен, следующий вертолет вылетает через 10 минут", 10)
      end
  end
)

REDSupportColumn = SPAWN:New("REDSupportColumn")
:InitLimit(6,0)
:OnSpawnGroup(
  function (SupColumn)
    SupColumn:HandleEvent(EVENTS.Dead)
    trigger.action.outTextForCoalition(coalition.side.BLUE, "Красная колонна выезжает из Небодзири, сектор LM64", 40 , false)
      function SupColumn:OnEventDead(EventData)
        if SupColumn:CountAliveUnits() == 0 then
          REDSupportColumn:SpawnScheduleStop()
          REDSupColTimeout:Start()
          trigger.action.outText("Красная колонна уничтожена, следующая будет через 10 минут", 40)
        end
      end
  end
)
:SpawnScheduled(30,0)

--SCHEDULERS*************************************************************************************************************************************

BLUESupColTimeout = SCHEDULER:New( nil,                           
  function()
      BLUESupportColumn:SpawnScheduleStart()
  end,
  {}, 600 )
BLUESupColTimeout:Stop()

BLUEHeliMarineGomi_SCHEDULER = SCHEDULER:New(nil,
  function()
    if GomiCapZoneSide == coalition.side.BLUE then
      BLUEHeliMarineGomi:Spawn()
      BLUEHeliMarineGomi_SCHEDULER:Stop()
    end
  end,
{}, 600)
BLUEHeliMarineGomi_SCHEDULER:Stop()

BLUEHeliMarineHashuri_SCHEDULER = SCHEDULER:New(nil,
  function()
    if HashuriCapZoneSide == coalition.side.BLUE then
      BLUEHeliMarineHashuri:Spawn()
      BLUEHeliMarineHashuri_SCHEDULER:Stop()
    end
  end,
{}, 600)
BLUEHeliMarineHashuri_SCHEDULER:Stop()

BLUEHeliMarineSurami_SCHEDULER = SCHEDULER:New(nil,
  function()
    if SuramiCapZoneSide == coalition.side.BLUE then
      BLUEHeliMarineSurami:Spawn()
      BLUEHeliMarineSurami_SCHEDULER:Stop()
    end
  end,
{}, 600)
BLUEHeliMarineSurami_SCHEDULER:Stop()


REDSupColTimeout = SCHEDULER:New( nil,                           
  function()
    REDSupportColumn:SpawnScheduleStart()
  end,
  {}, 600 )
REDSupColTimeout:Stop()

REDHeliMarineCipa_SCHEDULER = SCHEDULER:New(nil,
  function()
    if CipaCapZoneSide == coalition.side.RED then
      REDHeliMarineCipa:Spawn()
      REDHeliMarineCipa_SCHEDULER:Stop()
    end
  end,
{}, 600)
REDHeliMarineCipa_SCHEDULER:Stop()

REDHeliMarineSurami_SCHEDULER = SCHEDULER:New(nil,
  function()
    if SuramiCapZoneSide == coalition.side.RED then
      REDHeliMarineSurami:Spawn()
      REDHeliMarineSurami_SCHEDULER:Stop()
    end
  end,
{}, 600)
REDHeliMarineSurami_SCHEDULER:Stop()

REDHeliMarineHashuri_SCHEDULER = SCHEDULER:New(nil,
  function()
    if HashuriCapZoneSide == coalition.side.RED then
      REDHeliMarineHashuri:Spawn()
      REDHeliMarineHashuri_SCHEDULER:Stop()
    end
  end,
{}, 600)
REDHeliMarineHashuri_SCHEDULER:Stop()


--ФУНКЦИИ ДЛЯ КОЛОНН**********************************************************************

--Вызываются при прохождении определенного вэйпоинта
function BLUESupportColumnGomiFunc()
  local SAM = BLUEGomiForcesSAM:GetLastAliveGroup()
  local SAMCount = SAM:CountAliveUnits()
  if SAMCount ~= nil and SAMCount ~= 0 then
    SAM:Destroy()
    BLUEGomiForcesSAM:SetSpawnIndex(0)
    BLUEGomiForcesSAM:Spawn()
  end
  
  if GomiCapZoneSide == coalition.side.BLUE and HashuriCapZoneSide == coalition.side.RED then
    local SupCol = BLUESupportColumn:GetLastAliveGroup()
    local Counter = SupCol:CountAliveUnits()
    if Counter ~= 0 then
      local coltemp = {BLUESupColumnTemplate[Counter]}
      BLUEHashuriAtkColumn:InitRandomizeTemplate(coltemp)
      BLUEHashuriAtkColumn:Spawn()
    end
    SupCol:Destroy(true)
    BLUESupportColumn:SetSpawnIndex(0)
  end
end

function BLUESupportColumnHashuriFunc()
  local SAM = BLUEHashuriForcesSAM:GetLastAliveGroup()
  local SAMCount = SAM:CountAliveUnits()
  if SAMCount ~= nil and SAMCount ~= 0 then
    SAM:Destroy()
    BLUEHashuriForcesSAM:SetSpawnIndex(0)
    BLUEHashuriForcesSAM:Spawn()
  end
  
  if HashuriCapZoneSide == coalition.side.BLUE and SuramiCapZoneSide == coalition.side.RED then
    local SupCol = BLUESupportColumn:GetLastAliveGroup()
    local Counter = SupCol:CountAliveUnits()
    if Counter ~= 0 then
      local coltemp = {BLUESupColumnTemplate[Counter]}
      BLUESuramiAtkColumn:InitRandomizeTemplate(coltemp)
      BLUESuramiAtkColumn:Spawn()
    end
    SupCol:Destroy(true)
    BLUESupportColumn:SetSpawnIndex(0)
  end
end

function BLUESupportColumnSuramiFunc()
  local SAM = BLUESuramiForcesSAM:GetLastAliveGroup()
  local SAMCount = SAM:CountAliveUnits()
  if SAMCount ~= nil and SAMCount ~= 0 then
    SAM:Destroy()
    BLUESuramiForcesSAM:SetSpawnIndex(0)
    BLUESuramiForcesSAM:Spawn()
  end
  
  if SuramiCapZoneSide == coalition.side.BLUE and CipaCapZoneSide == coalition.side.RED then
    local SupCol = BLUESupportColumn:GetLastAliveGroup()
    local Counter = SupCol:CountAliveUnits()
    if Counter ~= 0 then
      local coltemp = {BLUESupColumnTemplate[Counter]}
      BLUECipaAtkColumn:InitRandomizeTemplate(coltemp)
      BLUECipaAtkColumn:Spawn()
    end
    SupCol:Destroy(true)
    BLUESupportColumn:SetSpawnIndex(0)
  end
end

function REDSupportColumnCipaFunc()
  local SAM = REDCipaForcesSAM:GetLastAliveGroup()
  local SAMCount = SAM:CountAliveUnits()
  if SAMCount ~= nil and SAMCount ~= 0 then
    SAM:Destroy()
    REDCipaForcesSAM:SetSpawnIndex(0)
    REDCipaForcesSAM:Spawn()
  end
  
  if SuramiCapZoneSide == coalition.side.BLUE and CipaCapZoneSide == coalition.side.RED then
    local SupCol = REDSupportColumn:GetLastAliveGroup()
    local Counter = SupCol:CountAliveUnits()
    if Counter ~= 0 then
      local coltemp = {REDSupColumnTemplate[Counter]}
      REDSuramiAtkColumn:InitRandomizeTemplate(coltemp)
      REDSuramiAtkColumn:Spawn()
    end
    SupCol:Destroy(true)
    REDSupportColumn:SetSpawnIndex(0)
  end
end

function REDSupportColumnSuramiFunc()
  local SAM = REDSuramiForcesSAM:GetLastAliveGroup()
  local SAMCount = SAM:CountAliveUnits()
  if SAMCount ~= nil and SAMCount ~= 0 then
    SAM:Destroy()
    REDSuramiForcesSAM:SetSpawnIndex(0)
    REDSuramiForcesSAM:Spawn()
  end
  
  if HashuriCapZoneSide == coalition.side.BLUE and SuramiCapZoneSide == coalition.side.RED then
    local SupCol = REDSupportColumn:GetLastAliveGroup()
    local Counter = SupCol:CountAliveUnits()
    if Counter ~= 0 then
      local coltemp = {REDSupColumnTemplate[Counter]}
      REDHashuriAtkColumn:InitRandomizeTemplate(coltemp)
      REDHashuriAtkColumn:Spawn()
    end
    SupCol:Destroy(true)
    REDSupportColumn:SetSpawnIndex(0)
  end
end

function REDSupportColumnHashuriFunc()
  local SAM = REDHashuriForcesSAM:GetLastAliveGroup()
  local SAMCount = SAM:CountAliveUnits()
  if SAMCount ~= nil and SAMCount ~= 0 then
    SAM:Destroy()
    REDHashuriForcesSAM:SetSpawnIndex(0)
    REDHashuriForcesSAM:Spawn()
  end
  
  if GomiCapZoneSide == coalition.side.BLUE and HashuriCapZoneSide == coalition.side.RED then
    local SupCol = REDSupportColumn:GetLastAliveGroup()
    local Counter = SupCol:CountAliveUnits()
    if Counter ~= 0 then
      local coltemp = {REDSupColumnTemplate[Counter]}
      REDGomiAtkColumn:InitRandomizeTemplate(coltemp)
      REDGomiAtkColumn:Spawn()
    end
    SupCol:Destroy(true)
    REDSupportColumn:SetSpawnIndex(0)
  end
end


--ZONE CONTROL***************************************************************************************************************************


--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function GomiCaptureZone:OnEnterCaptured()  --при захвате зоны какой либо коалицией
  GomiCapZoneSide = self:GetCoalition()
  if GomiCapZoneSide == coalition.side.BLUE then
    --если Gomi захватили синие ПОТОМ ПРИДУМАТЬ И ДОПИЛИТЬ
    
  else
    --если Gomi захватили красные
    trigger.action.outText("Красные захватили Gomi, Синие проиграли", 120)
  end
end

GomiCaptureZone:__Guard(1)
GomiCaptureZone:Start(10,20)

function HashuriCaptureZone:OnEnterCaptured()  --при захвате зоны какой либо коалицией
  HashuriCapZoneSide = self:GetCoalition()
  if HashuriCapZoneSide == coalition.side.BLUE then
    --если Hashuri захватили синие спавним в городе силы обороны, запускаем конвой поддержки
    REDHeliMarineHashuri_SCHEDULER:Stop()
    REDHeliMarineSurami_SCHEDULER:Start()
    BLUEHashuriForcesTanks:Spawn()
    BLUEHashuriForcesSAM:Spawn()
    BLUEHashuriForcesSoldiers:Spawn()
    BLUEHeliMarineHashuri:Spawn()
    BLUESuramiAtkSoldiers:Spawn()
    BlueBomberAtkZone = SuramiCapZone
    RedBomberAtkZone = HashuriCapZone
    trigger.action.outText("Хашури снова захвачена Синими войсками", 30)
  else
    --если Hashuri захватили красные
    BLUEHeliMarineHashuri_SCHEDULER:Stop()
    BLUEHeliMarineGomi:Spawn()
    REDHeliMarineSurami_SCHEDULER:Stop()
    REDHeliMarineHashuri_SCHEDULER:Start()
    REDHashuriForcesTanks:Spawn()
    REDHashuriForcesSAM:Spawn()
    REDHashuriForcesSoldiers:Spawn()
    REDGomiAtkSoldiers:Spawn()
    BlueBomberAtkZone = HashuriCapZone
    RedBomberAtkZone = GomiCapZone
    trigger.action.outText("Хашури захвачена Красными войсками", 30)
  end
end

HashuriCaptureZone:__Guard(1)
HashuriCaptureZone:Start(10,20)


--события в зоне "при захвате" и "при защите"


--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function SuramiCaptureZone:OnEnterCaptured()  --при захвате зоны какой либо коалицией
  SuramiCapZoneSide = self:GetCoalition()
  if SuramiCapZoneSide == coalition.side.BLUE then
    --если сурами захватили синие спавним в городе силы обороны, запускаем конвой поддержки
    REDHeliMarineSurami_SCHEDULER:Stop()
    REDHeliMarineCipa:Spawn()
    REDSuramiAtkSoldiers:Spawn()
    BLUESuramiForcesTanks:Spawn()
    BLUESuramiForcesSAM:Spawn()
    BLUESuramiForcesSoldiers:Spawn()
    BLUEHeliMarineHashuri_SCHEDULER:Stop()
    BLUEHeliMarineSurami:Spawn()
    BlueBomberAtkZone = CipaCapZone
    RedBomberAtkZone = SuramiCapZone
    trigger.action.outText("Сурами захвачена Синими войсками", 30)
  else
    --если сурами захватили красные
    BLUEHeliMarineSurami_SCHEDULER:Stop()
    BLUEHeliMarineHashuri:Spawn()
    REDSuramiForcesTanks:Spawn()
    REDSuramiForcesSAM:Spawn()
    REDSuramiForcesSoldiers:Spawn()
    REDHeliMarineSurami:Spawn()
    BlueBomberAtkZone = SuramiCapZone
    RedBomberAtkZone = HashuriCapZone
    trigger.action.outText("Сурами снова захвачена Красными войсками", 30)
  end
end

SuramiCaptureZone:__Guard(1)
SuramiCaptureZone:Start(10,20)


--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function CipaCaptureZone:OnEnterCaptured()  --при захвате зоны какой либо коалицией
  CipaCapZoneSide = self:GetCoalition()
  if CipaCaptureZone == coalition.side.BLUE then
  --синие

    trigger.action.outText("Ципа снова захвачена Синими войсками, Красные проиграли", 90)
  else
  --красные
  
    trigger.action.outText("Ципа захвачена Красными войсками", 30)
  end
end

CipaCaptureZone:__Guard(1)
CipaCaptureZone:Start(10,20)

  
env.info("BATTLEFIELD loaded ")
trigger.action.outText("BATTLEFIELD loaded ", 5)